#!/usr/bin/python
# -*- coding: utf-8 -*-

from lxml import etree
import subprocess
import sys
import tempfile
import os
infile = "test.xml"
outfile = "test.mml.xml"
converterscript = "latex2mml.py"

DB_NS="http://docbook.org/ns/docbook"
DB = "{%s}" % DB_NS
XI_NS="http://www.w3.org/2001/XInclude"
XI = "{%s}" % XI_NS
XLINK_NS="http://www.w3.org/1999/xlink"
XLINK = "{%s}" % XLINK_NS
HTML_NS="http://www.w3.org/1999/xhtml"
HTML = "{%s}" % HTML_NS
MML_NS = "http://www.w3.org/1998/Math/MathML"
MML = "{%s}" % MML_NS

XPATH = {'db' : DB_NS,
         'xi' : XI_NS,
         'xlink' : XLINK_NS,
         'html' : HTML_NS,
         'mml': MML_NS}

dirname = os.path.dirname(os.path.realpath(__file__))
converter =  os.path.join(os.path.abspath(dirname)+'/'+converterscript)

doc = etree.parse(infile)
eq = doc.xpath(u"//db:mathphrase[@role='latex']",namespaces=XPATH)
if eq:
    for e in eq:
        exe = []
        latex=e.text
        tmpfile = tempfile.mktemp()
        exe.append(converter)
        exe.append(tmpfile)
        with open(tmpfile, "w") as tf:
             tf.write(latex)
        resxml = subprocess.Popen(exe,stdout=subprocess.PIPE,
                                      stderr=subprocess.PIPE)
        (stdout, stderr) = resxml.communicate()
        if stdout and stderr:
            print "Warning :"+" ".join(exe)+" : [ "+stderr+" ]"
        elif stderr:
            sys.exit("Error running script : "+" ".join(exe)+" ERROR : [ "+stderr+" ]")
 #       os.remove(tmpfile)
        mml=etree.fromstring(stdout)
        p=e.getparent()
        p.replace(e,mml)
        with open(outfile,'w') as of:
            of.write(etree.tostring(doc,encoding='UTF-8',pretty_print=False))
